
/*
	tab2tag - Convert a tab seperated file to a tag file

Note that this is ALPHA software, developed piecemeal while I
was testing various ideas.


Released under the GNU Copyright.

        Author: John Lines <john@paladin.demon.co.uk>




Things to do

        Should allow arguments to select tags which will not be displayed,
	and much more


*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXTAGLABELS 20
#define MAXLABELLEN 127
#include "tagtypes.h"

/* Global flags */
int recbufsize=10000;        /* Size of a record buffer */
int doheader=1;
int numtaglabels=0;
char taglabels[MAXTAGLABELS][MAXLABELLEN];

struct tagrecord *gettabrec(FILE *f,char *fieldbuffer);

void parseargs(int argc,char *argv[]);

void main(int argc, char *argv[]) {

 struct tagrecord *record;
 char *fieldbuffer;

parseargs(argc,argv);


fieldbuffer=malloc(recbufsize);


while (!feof(stdin)) {
  record=gettabrec(stdin,fieldbuffer);
  puttagrec(stdout,record);
 }


}

void parseargs(int argc,char *argv[])
{

int arg=1;

/* Look for flags */

while ((arg<argc) && (argv[arg][0]=='-')) {
 switch (argv[arg][1]) {
case 'h':
  doheader=0; break;
case 't':
  arg++;
  while ((arg<argc) && (argv[arg][0]!='-')) {
  strncpy(taglabels[numtaglabels],argv[arg],MAXLABELLEN); numtaglabels++;
  arg++;
  }
  break;
default:
   fprintf(stderr,"Tag2tab - unknown switch %c\n",argv[arg][1]);
}
arg++;
}


}


struct tagrecord *gettabrec(FILE *f,char *fieldbuffer)
{

/* need to deal with the cases of
       more tab fields than labels
	more labels than tab fields
*/

 char tagname[128];
 struct tagrecord *current=0;
 struct tagrecord *previous=0;
 struct tagrecord *first=0;

 int labelindex=0;
 int bufptr=0;
 char ch;


while (!feof(f)) {
 ch=fgetc(f);
 if ((ch =='\t')||(ch=='\n')) {
      fieldbuffer[bufptr]=0;
       /* allocate a record structure for the fields */
         current= (struct tagrecord *)malloc(sizeof(struct tagrecord));
         if (previous!=0) previous->next=current;
         previous=current;
	strncpy(tagname,taglabels[labelindex],MAXLABELLEN);
	labelindex++;
         current->tagname=malloc(strlen(tagname)+1);
         strcpy(current->tagname,tagname);
         current->value=malloc(strlen(fieldbuffer)+1);
         strcpy(current->value,fieldbuffer);
         current->delimiter=0;
         current->next=0;
         if (first==0) first=current;
	bufptr=0;
	if (ch=='\n') {
       /* allocate a record for an end label */
         current= (struct tagrecord *)malloc(sizeof(struct tagrecord));
         if (previous!=0) previous->next=current;
         previous=current;
        strcpy(tagname,"End");
         current->tagname=malloc(strlen(tagname)+1);
         strcpy(current->tagname,tagname);
         current->value=0;
         current->delimiter=0;
         current->next=0;
         if (first==0) first=current;

            if (current != 0) current->next=0;
         return first;
	}
  }
 else {

      fieldbuffer[bufptr]=ch;
      bufptr++;
  } 

}

return 0;
}
